#import dependencies
from bioblend import galaxy
import argparse, requests, os
import psycopg2

#import Classes
from database import Database

def get_args() :
    parser = argparse.ArgumentParser()
    parser.add_argument("--host",help="",default=None, required=True )
    parser.add_argument("-u","--user",help="",default=None, required=True)
    parser.add_argument("-db","--database",help="",default=None, required=True)
    parser.add_argument("-p","--password",help="",default=None, required=True)
    parser.add_argument("-f","--file",help="file containing all passwords generated by transfer_galaxy_users.py with --save_passwords option", required=True)
    args = parser.parse_args()
    return args

def init_passwords_dictionary(path):
    user_passwords = {}
    with open(path,"r") as pass_file:
        for line in pass_file:
            line = line.split('\t')
            user_passwords[line[0]] = line[1]
    return user_passwords

def main():

    #get args from command
    print ("get args")
    args = get_args()

    #init database instances
    bdd = Database(user = args.user, password = args.password, host = args.host, database = args.database)
    print ('reference psql database: '+bdd.database)

    #Get passwords
    user_passwords = init_passwords_dictionary(args.file)

    #Update passwords
    for mail in user_passwords:
        bdd.update_password(mail, user_passwords[mail])
        print (mail+" password updated")

if __name__ == "__main__":
    # execute only if run as a script
    main()
